Open In App

C Program for Minimum number of jumps to reach end

Write a C program for a given array arr[] where each element represents the maximum number of steps that can be made forward from that index. The task is to find the minimum number of jumps to reach the end of the array starting from index 0.
If an element is 0, then cannot move through that element.

Examples:



Input: arr[] = {1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9}
Output: 3 (1-> 3 -> 9 -> 9)
Explanation: Jump from 1st element to 2nd element as there is only 1 step. Now there are three options 5, 8 or 9. If 8 or 9 is chosen then the end node 9 can be reached. So 3 jumps are made.

Input: arr[] = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}
Output: 10
Explanation: In every step a jump is needed so the count of jumps is 10.



C Program for Minimum number of jumps to reach end using Recursion:

Start from the first element and recursively call for all the elements reachable from the first element. The minimum number of jumps to reach end from first can be calculated using the minimum value from the recursive calls. 

minJumps(start, end) = 1 + Min(minJumps(k, end)) for all k reachable from start.

Step-by-step approach:

Below is the implementation of the above approach:




// C program to find Minimum
// number of jumps to reach end
#include <limits.h>
#include <stdio.h>
 
// Returns minimum number of
// jumps to reach arr[h] from arr[l]
int minJumps(int arr[], int l, int h)
{
    // Base case: when source and destination are same
    if (h == l)
        return 0;
 
    // When nothing is reachable from the given source
    if (arr[l] == 0)
        return INT_MAX;
 
    // Traverse through all the points
    // reachable from arr[l]. Recursively
    // get the minimum number of jumps
    // needed to reach arr[h] from these
    // reachable points.
    int min = INT_MAX;
    for (int i = l + 1; i <= h && i <= l + arr[l]; i++) {
        int jumps = minJumps(arr, i, h);
        if (jumps != INT_MAX && jumps + 1 < min)
            min = jumps + 1;
    }
 
    return min;
}
 
// Driver program to test above function
int main()
{
    int arr[] = {1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9 };
    int n = sizeof(arr) / sizeof(arr[0]);
    printf("Minimum number of jumps to reach end is %d ",
        minJumps(arr, 0, n - 1));
    return 0;
}

Output
Minimum number of jumps to reach end is 3

Time complexity: O(nn). There are maximum n possible ways to move from an element. So the maximum number of steps can be nn.
Auxiliary Space: O(n). For recursion call stack.

C Program for Minimum number of jumps to reach end Using Dynamic Programming (Memoization):

It can be observed that there will be overlapping subproblems. 
For example in array, arr[] = {1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9} minJumps(3, 9) will be called two times as arr[3] is reachable from arr[1] and arr[2]. So this problem has both properties (optimal substructure and overlapping subproblems) of Dynamic Programming.

Step-by-step approach:

Below is the implementation of the above approach:




#include <stdio.h>
#include <limits.h>
 
int jump(int *nums, int idx, int end, int *memo) {
    if (idx == end) {
        return 0;
    }
 
    if (memo[idx] != -1) {
        return memo[idx];
    }
 
    int min_jumps = INT_MAX - 1;
 
    for (int j = nums[idx]; j >= 1; j--) {
        if (idx + j <= end) {
            int jumps = 1 + jump(nums, idx + j, end, memo);
            min_jumps = (jumps < min_jumps) ? jumps : min_jumps;
        }
    }
 
    memo[idx] = min_jumps;
    return min_jumps;
}
 
int minJumps(int *nums, int n) {
    int *memo = (int *)malloc(n * sizeof(int));
    for (int i = 0; i < n; i++) {
        memo[i] = -1;
    }
    int result = jump(nums, 0, n - 1, memo);
    free(memo);
    return result;
}
 
int main() {
    int n = 11;
    int arr[] = {1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9};
    printf("%d\n", minJumps(arr, n));
    return 0;
}

Output
3

Time complexity: O(n2)
Auxiliary Space: O(n), because of recursive stack space and memo array.

C Program for Minimum number of jumps to reach end using Dynamic Programming (Tabulation):

Step-by-step approach:

Below is the implementation of the above approach:




// C program for Minimum number
// of jumps to reach end
#include <limits.h>
#include <stdio.h>
 
int min(int x, int y) { return (x < y) ? x : y; }
 
// Returns minimum number of
// jumps to reach arr[n-1] from arr[0]
int minJumps(int arr[], int n)
{
    // jumps[n-1] will hold the result
    int jumps[n];
    int i, j;
 
    if (n == 0 || arr[0] == 0)
        return INT_MAX;
 
    jumps[0] = 0;
 
    // Find the minimum number of
    // jumps to reach arr[i]
    // from arr[0], and assign this
    // value to jumps[i]
    for (i = 1; i < n; i++) {
        jumps[i] = INT_MAX;
        for (j = 0; j < i; j++) {
            if (i <= j + arr[j] && jumps[j] != INT_MAX) {
                jumps[i] = min(jumps[i], jumps[j] + 1);
                break;
            }
        }
    }
    return jumps[n - 1];
}
 
// Driver program to test above function
int main()
{
    int arr[] = { 1, 3, 5, 8, 9, 2, 6, 7, 6, 8, 9 };
    int size = sizeof(arr) / sizeof(int);
    printf("Minimum number of jumps to reach end is %d ",
        minJumps(arr, size));
    return 0;
}

Output
Minimum number of jumps to reach end is 3

Time Complexity: O(n2)
Auxiliary Space: O(n), since n extra space has been taken.

Please refer complete article on Minimum number of jumps to reach end for more details!


Article Tags :